class data:
    class main:
        def __init__(self, log, d):
            self.type=d
            self.log=log
    class sour:
        def __init__(self, log, d):
            self.log=log
            self.type=d
    class yp_a:
        def __init__(self, log, d):
            self.log=log
            self.type=d
    class SHOU:
        def __init__(self, log, d):
            self.log=log
            self.type=d
    class dest:
        class start:
            def __init__(self, log):
                self.type="start"
                self.uid=int(log[log.find("UID")+5:log.find(")",log.find("UID"))])
                self.l=int(log[log.find("L: ")+3:log.find("]",log.find("L:"))])
                self.client=log[log.find("A: ")+3:log.find("}",log.find("A: "))]
        class close:
            def __init__(self, log):
                self.type="close"
                self.uid=int(log[log.find("UID")+5:log.find(")",log.find("UID"))])
                self.time=int(log[log.find("(")+1:log.find("seconds")-1])
                self.byte=int(log[log.find("Bytes:")+7:log.find("}")])
                self.l=int(log[log.find("L: ")+3:log.find("]",log.find("L:"))])
        def __init__(self, log, ip):
            self.ip=ip[6:]
            self.log=log
            self.type="dest"
            if self.log[0:5]=="start":
                self.user=self.start(self.log)
            elif self.log[0:5]=="conne":
                self.user=self.close(self.log)
            else:
                self.user=None
            
    class yp_t:
        def __init__(self, log, d):
            self.touch=True
            if log[0:5]=="error":
                self.touch=False
            self.type=d
            self.log=log
    class yp_r:
        def __init__(self, log, d):
            self.rem=True
            self.type=d
            self.log=log
    class http:
        def __init__(self, log, ip):
            self.log=log
            self.type="http"
            self.ip=ip[5:]
    def __init__(self, time, dtype, line):
        self.time=time
        exec "self.mine= self."+dtype[0:4]+"(line, dtype)"
    def __str__(self):
        st=self.time+" ["+self.mine.type
        if self.mine.type=="dest" or self.mine.type=="http":
            st+=":"+self.mine.ip
        st+="] "+self.mine.log
        return st
    
class session:
    def __init__(self, time, uid, ip, length, size):
        self.time=time
        self.uid=uid
        self.ip=ip
        self.length=length
        self.size=size
    def __str__(self):
        return self.time+" (UID:"+str(self.uid)+") {IP:"+self.ip+"} "+str(self.length)+"sec, "+str(self.size)+"B."
    
def parse(line):
    dtype=line[line.find('[')+1:line.find(']')]
    time=line[0:19]
    return data(time,dtype,line[line.find(']')+2:])

def timeformat(time):
    return str(time/(60*60*24))+" days, "+str((time%(60*60*24))/(60*60))+" hours, "+str(((time%(60*60*24))%(60*60))/60)+" min, and "+str(((time%(60*60*24))%(60*60))%6)+" sec"

def sizeformat(size):
    return str(size/(1024**3))+"GB, "+str((size%1024**3)/(1024**2))+"MB, "+str(((size%1024**3)%1024**2)/1024)+"KB, and "+str(((size%1024**3)%1024**2)%1024)+"B"

print "Parsing log file, this may take a while..."
print
log = open("sc_serv.log")

u=0
b=0
cb=0
s=0
cs=0
ts=0
m=0
cu=0
cul=[]
cun=0
un=0
cm=0
ul=[]
t=0
ms=0
msip="0.0.0.0"
users={}
userc={}
sess=[]
mt=0
sdt=[]

for line in log:
    temp=parse(line)
    if temp.mine.type=="yp_tch" and temp.mine.touch:
        t+=1
    if temp.mine.type=="dest" and temp.mine.user!=None:
        if temp.mine.user.type=="start" and temp.mine.user.client!="SHOUTcast Directory Tester":
            u+=1
            cu+=1
            if ul.count(temp.mine.ip)==0:
                ul.append(temp.mine.ip)
                un+=1
                cul.append(temp.mine.ip)
                cun+=1
            if temp.mine.user.l>m:
                m=temp.mine.user.l
                mt=0
        elif temp.mine.user.type=="start" and temp.mine.user.client=="SHOUTcast Directory Tester":
            cu+=1
            if sdt.count(temp.mine.ip)==0:
                sdt.append(temp.mine.ip)
        if temp.mine.user.type=="close":
           
            b+=temp.mine.user.byte
            s+=temp.mine.user.time
            if temp.mine.user.l==0:
                ts+=temp.mine.user.time
            if temp.mine.user.l+1==m:
                mt+=temp.mine.user.time
            if temp.mine.user.time>ms:
                ms=temp.mine.user.time
                msip=temp.mine.ip
            if temp.mine.user.time>=30 and sdt.count(temp.mine.ip)==0:
                if temp.mine.ip=="205.188.234.97":
                    print temp.mine.user.time
                sess.append(session(temp.time, temp.mine.user.uid, temp.mine.ip, temp.mine.user.time, temp.mine.user.byte))
                cb+=temp.mine.user.byte
                cs+=temp.mine.user.time
                if users.get(temp.mine.ip, None)!=None:
                    users[temp.mine.ip]+=temp.mine.user.time
                    userc[temp.mine.ip]+=1
                else:
                    users[temp.mine.ip]=temp.mine.user.time
                    userc[temp.mine.ip]=1
                if temp.mine.user.l+1>cm:
                    cm=temp.mine.user.l
            else:
                if cul.count(temp.mine.ip)!=0:
                    cul.pop(cul.index(temp.mine.ip))
                    cun-=1
                cu-=1
            
log.close()
mu=0
muip="0.0.0.0"
mau=0
mauip="0.0.0.0"
mru=-1
mruip="0.0.0.0"
mrc=0
for ip in users:
    if users[ip]>mu:
        mu=users[ip]
        muip=ip
    if userc[ip]-1>mru:
        mru=userc[ip]-1
        mruip=ip
    if users[ip]/userc[ip]>mau:
        mau=users[ip]/userc[ip]
        mauip=ip
    if userc[ip]>1:
        mrc+=1
if u==0:
    print "No listeners yet."
else:
    print
    print "     -General Stats-"
    print
    print "Total session count: ",u
    print "Unique users: ",un
    print "Total listened: ",timeformat(s)+"."
    print "Total transferred: ",sizeformat(b)+"."
    print "Max listeners: ",m
    print "Transfer rate: ",round(int(b/s)/1024.,3),"KB/s"
    print "Max transfer rate: ",round(m*int(b/s)/1024.,3),"KB/s"
    print
    raw_input("Press enter to continue.")
    print
    print "Note that the following stats ignore sessions less than 30 seconds long."
    print
    print "     -Aggregate Stats-"
    print
    print "Sessions: ",cu
    print "Unique listeners: ",cun
    print "Average number of returns per user: ",round((cu-cun)/(cun*1.),3)
    print "Avg. user listen time: ",timeformat(int(cs/cun))+"."
    print "Avg. user transfer: ",sizeformat(cb/cun)+"."
    print "Avg. session time: ",timeformat(cs/cu)+"."
    print "Avg. session transfer: ",sizeformat(cb/cu)+"."
    print
    raw_input("Press enter to continue.")
    print
    print "     -Listener Stats-"
    print
    print "Longest session by: ",msip
    print "Session length: ",timeformat(ms)+"."
    print "Biggest fan: ",muip
    print "Listened for: ",timeformat(mu)+"."
    print "Steady listener: ",mauip
    print "Session length average: ",timeformat(mau)+"."
    print "Most loyal: ",mruip
    print "Number of returns: ",mru
    print "Percentage of users who return: "+str(round(((mrc*1.)/cun)*100,3))+"%"
    print
    if (t==0):
        print "Set TchLog=yes in your sv_serv.ini file's logging section to enable uptime estimation and derived stats."
    else:
        raw_input("Press enter to continue.")
        print
        print "     -Uptime Stats-"
        print
        print "Touched by SHOUTcast",t,"times."
        print "Estimated uptime: ",timeformat(t*3*60+t*5)+"."
        print "Time with listeners: ",timeformat(ts)+"."
        print "Time without listeners: ",timeformat(t*3*60+t*5-ts)+"."
        print "Percentage of stream heard: "+str(round(ts/(t*3*60.+t*5)*100.,3))+"%"
        print "Percentage of time with "+str(m)+" listeners: "+str(round((mt/(t*3*60.+t*5))*100,3))+"%"
        print "Average aggregate transfer rate: ",round((b/1024.)/(t*3*60+t*5),3),"KB/s" 
print
inp=raw_input("Show full session log? (y/n): ")
if inp=="y":
    c=0
    print
    for st in sess:
        c+=1
        print st
        if c==23:
            print
            raw_input("Press enter to continue.")
            c=0
            print
    print
    raw_input("Press enter to finish.")
